/*
 * hdw-sniff, sniffer using pcap lib
 *
 * author: hackbard@hackdaworld.dyndns.org
 */

#include <stdio.h>
#include <pcap.h>

/* IEEE 802.3 stuff -- i will concentrate on .11 stuff before! */
#include <netinet/if_ether.h>

/* IEEE 802.11 stuff -- will become one include later ... */
#include "ieee80211.h" /* from hunz's aeolus, short hostap_wlan.h */
#include "ieee802_11.h" /* from pcmcia-cs */

#include "hdw-sniff.h" /* my functions */

#define MAX_PACKAGES 3

int main(int argc, char *argv[]) {

	int i,count;
	char pcap_error[PCAP_ERRBUF_SIZE];
	pcap_t *pcap_handle;
	const u_char *package;
	struct pcap_pkthdr pcap_header;
	struct ethhdr *e_hdr;
	struct ieee802_11_hdr *w_hdr;
	
	/* parse the arguments */
	if(argc<2) {
		printf("usage: %s <interface> <logfile>\n",argv[0]);
		return 0;
	}
	if(argc!=3) {
		printf("no logfile specified, writing to stdout ...\n");
	}
	
	/* start pcap session */
	pcap_handle=pcap_open_live(argv[1],BUFSIZ,1,-1,pcap_error);
	if(pcap_handle==NULL) {
		printf("%s: %s\n",argv[0],pcap_error);
		return 1;
	}
	
	/* grab a package until user breaks */
	count=0;
	while (count<MAX_PACKAGES) {
	count++;
	printf("\n");
	if((package=pcap_next(pcap_handle,&pcap_header))!=NULL) {
		printf("---> package %d ---- %s",count,
				ctime((const time_t*)&pcap_header.ts.tv_sec));
		printf("pcap header: ");
		printf("capture length=%d ",pcap_header.caplen);
		printf("length(off wire)=%d\n",pcap_header.len);
	}
	
	/* is ieee802.11 ? -- we assume yes :) */
	
	
	/* ethernet */
	e_hdr=(struct ethhdr *)package;
	/* what types ? */
	printf("types = ");
	printf("%x  ",ntohs(e_hdr->h_proto));
	printf("dest_addr = ");
	for(i=0;i<ETH_ALEN;i++)
	printf("%x%s",*(e_hdr->h_dest+i),((i==ETH_ALEN-1)?" ":":"));
	printf(" src_addr = ");
	for(i=0;i<ETH_ALEN;i++)
	printf("%x%s",*(e_hdr->h_source+i),((i==ETH_ALEN-1)?"\n":":"));
	if(ntohs(e_hdr->h_proto)==ETH_P_IP) {
		printf("ip protocol: ");
		// printf("
	}
	printf("rest:\n");
	for(i=sizeof(struct ethhdr);i<pcap_header.caplen;i++)
		printf("%x ",*(package+i));
	printf("\n");
	}
	printf("\n");
	printf("just beacon frames, ha? - wake up early! :)\n");
	printf("\n");
}
